Index: uspace/lib/ui/private/clickmatic.h
===================================================================
--- uspace/lib/ui/private/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/clickmatic.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,65 @@
+/*
+ * Copyright (c) 2022 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Clickmatic structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_CLICKMATIC_H
+#define _UI_PRIVATE_CLICKMATIC_H
+
+#include <fibril_synch.h>
+#include <gfx/coord.h>
+
+/** Actual structure of clickmatic.
+ *
+ * This is private to libui.
+ */
+struct ui_clickmatic {
+	/** Containing user interface */
+	struct ui *ui;
+	/** Callbacks */
+	struct ui_clickmatic_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Click position */
+	gfx_coord2_t pos;
+	/** Timer */
+	fibril_timer_t *timer;
+};
+
+extern void ui_clickmatic_clicked(ui_clickmatic_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/entry.h
===================================================================
--- uspace/lib/ui/private/entry.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/entry.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -92,5 +92,4 @@
 } ui_entry_geom_t;
 
-extern errno_t ui_entry_insert_str(ui_entry_t *, const char *);
 extern ui_evclaim_t ui_entry_key_press_ctrl(ui_entry_t *, kbd_event_t *);
 extern ui_evclaim_t ui_entry_key_press_shift(ui_entry_t *, kbd_event_t *);
Index: uspace/lib/ui/private/filedialog.h
===================================================================
--- uspace/lib/ui/private/filedialog.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/filedialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,4 +47,6 @@
 	/** File name entry */
 	struct ui_entry *ename;
+	/** File list */
+	struct ui_file_list *flist;
 	/** OK button */
 	struct ui_pbutton *bok;
Index: uspace/lib/ui/private/filelist.h
===================================================================
--- uspace/lib/ui/private/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/filelist.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,126 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file File list
+ */
+
+#ifndef _UI_PRIVATE_FILELIST_H
+#define _UI_PRIVATE_FILELIST_H
+
+#include <gfx/color.h>
+#include <ipc/loc.h>
+#include <ui/list.h>
+#include <ui/window.h>
+#include <stdint.h>
+#include <types/ui/filelist.h>
+
+/** File list entry attributes */
+struct ui_file_list_entry_attr {
+	/** File name */
+	const char *name;
+	/** File size */
+	uint64_t size;
+	/** @c true iff entry is a directory */
+	bool isdir;
+	/** Service number for service special entries */
+	service_id_t svc;
+};
+
+/** File list entry */
+struct ui_file_list_entry {
+	/** Containing file list */
+	struct ui_file_list *flist;
+	/** List entry */
+	ui_list_entry_t *entry;
+	/** File name */
+	char *name;
+	/** File size */
+	uint64_t size;
+	/** @c true iff entry is a directory */
+	bool isdir;
+	/** Service number for service special entries */
+	service_id_t svc;
+};
+
+/** File list.
+ *
+ * Allows browsing files and directories.
+ */
+typedef struct ui_file_list {
+	/** Base control object */
+	struct ui_control *control;
+
+	/** Containing window */
+	struct ui_window *window;
+
+	/** UI list */
+	ui_list_t *list;
+
+	/** Callbacks */
+	struct ui_file_list_cb *cb;
+
+	/** Callback argument */
+	void *cb_arg;
+
+	/** Directory-type entry color */
+	gfx_color_t *dir_color;
+
+	/** Service-type entry color */
+	gfx_color_t *svc_color;
+
+	/** Directory */
+	char *dir;
+} ui_file_list_t;
+
+extern bool ui_file_list_is_active(ui_file_list_t *);
+extern void ui_file_list_entry_destroy(ui_file_list_entry_t *);
+extern void ui_file_list_clear_entries(ui_file_list_t *);
+extern errno_t ui_file_list_sort(ui_file_list_t *);
+extern int ui_file_list_entry_ptr_cmp(const void *, const void *);
+extern void ui_file_list_entry_attr_init(ui_file_list_entry_attr_t *);
+extern errno_t ui_file_list_entry_append(ui_file_list_t *,
+    ui_file_list_entry_attr_t *);
+extern ui_file_list_entry_t *ui_file_list_first(ui_file_list_t *);
+extern ui_file_list_entry_t *ui_file_list_last(ui_file_list_t *);
+extern ui_file_list_entry_t *ui_file_list_next(ui_file_list_entry_t *);
+extern ui_file_list_entry_t *ui_file_list_prev(ui_file_list_entry_t *);
+extern errno_t ui_file_list_open_dir(ui_file_list_t *, ui_file_list_entry_t *);
+extern errno_t ui_file_list_open_file(ui_file_list_t *, ui_file_list_entry_t *);
+extern void ui_file_list_activate_req(ui_file_list_t *);
+extern void ui_file_list_selected(ui_file_list_t *, const char *);
+extern errno_t ui_file_list_paint(ui_file_list_t *);
+extern int ui_file_list_list_compare(ui_list_entry_t *, ui_list_entry_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/list.h
===================================================================
--- uspace/lib/ui/private/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/list.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,143 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file UI list
+ */
+
+#ifndef _UI_PRIVATE_LIST_H
+#define _UI_PRIVATE_LIST_H
+
+#include <adt/list.h>
+#include <gfx/color.h>
+#include <gfx/coord.h>
+#include <ipc/loc.h>
+#include <ui/window.h>
+#include <stdint.h>
+#include <types/ui/list.h>
+
+/** List entry */
+struct ui_list_entry {
+	/** Containing list */
+	struct ui_list *list;
+	/** Link to @c flist->entries */
+	link_t lentries;
+	/** Entry caption */
+	char *caption;
+	/** User argument */
+	void *arg;
+	/** Custom color or @c NULL to use default color */
+	gfx_color_t *color;
+	/** Custom background color or @c NULL to use default color */
+	gfx_color_t *bgcolor;
+};
+
+/** UI list.
+ *
+ * Displays a scrollable list of entries.
+ */
+typedef struct ui_list {
+	/** Base control object */
+	struct ui_control *control;
+
+	/** Containing window */
+	ui_window_t *window;
+
+	/** Callbacks */
+	struct ui_list_cb *cb;
+
+	/** Callback argument */
+	void *cb_arg;
+
+	/** List rectangle */
+	gfx_rect_t rect;
+
+	/** Scrollbar */
+	struct ui_scrollbar *scrollbar;
+
+	/** List entries (list of ui_list_entry_t) */
+	list_t entries;
+
+	/** Number of entries */
+	size_t entries_cnt;
+
+	/** First entry of current page */
+	ui_list_entry_t *page;
+
+	/** Index of first entry of current page */
+	size_t page_idx;
+
+	/** Cursor position */
+	ui_list_entry_t *cursor;
+
+	/** Index of entry under cursor */
+	size_t cursor_idx;
+
+	/** @c true iff the list is active */
+	bool active;
+} ui_list_t;
+
+extern gfx_coord_t ui_list_entry_height(ui_list_t *);
+extern errno_t ui_list_entry_paint(ui_list_entry_t *, size_t);
+extern errno_t ui_list_paint(ui_list_t *);
+extern ui_evclaim_t ui_list_kbd_event(ui_list_t *, kbd_event_t *);
+extern ui_evclaim_t ui_list_pos_event(ui_list_t *, pos_event_t *);
+extern unsigned ui_list_page_size(ui_list_t *);
+extern void ui_list_inside_rect(ui_list_t *, gfx_rect_t *);
+extern void ui_list_scrollbar_rect(ui_list_t *, gfx_rect_t *);
+extern gfx_coord_t ui_list_scrollbar_pos(ui_list_t *);
+extern void ui_list_scrollbar_update(ui_list_t *);
+extern void ui_list_clear_entries(ui_list_t *);
+extern ui_list_entry_t *ui_list_page_nth_entry(ui_list_t *,
+    size_t, size_t *);
+extern void ui_list_cursor_move(ui_list_t *, ui_list_entry_t *,
+    size_t);
+extern void ui_list_cursor_up(ui_list_t *);
+extern void ui_list_cursor_down(ui_list_t *);
+extern void ui_list_cursor_top(ui_list_t *);
+extern void ui_list_cursor_bottom(ui_list_t *);
+extern void ui_list_page_up(ui_list_t *);
+extern void ui_list_page_down(ui_list_t *);
+extern void ui_list_scroll_up(ui_list_t *);
+extern void ui_list_scroll_down(ui_list_t *);
+extern void ui_list_scroll_page_up(ui_list_t *);
+extern void ui_list_scroll_page_down(ui_list_t *);
+extern void ui_list_scroll_pos(ui_list_t *, size_t);
+extern void ui_list_activate_req(ui_list_t *);
+extern void ui_list_selected(ui_list_entry_t *);
+extern int ui_list_entry_ptr_cmp(const void *, const void *);
+extern size_t ui_list_entry_get_idx(ui_list_entry_t *);
+extern void ui_list_entry_destroy(ui_list_entry_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/menu.h
===================================================================
--- uspace/lib/ui/private/menu.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/menu.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,4 +41,5 @@
 #include <gfx/coord.h>
 #include <stdbool.h>
+#include <types/common.h>
 #include <types/ui/menu.h>
 #include <types/ui/resource.h>
@@ -49,8 +50,6 @@
  */
 struct ui_menu {
-	/** Containing menu bar */
-	struct ui_menu_bar *mbar;
-	/** Link to @c bar->menus */
-	link_t lmenus;
+	/** Parent window */
+	struct ui_window *parent;
 	/** Caption */
 	char *caption;
@@ -67,4 +66,10 @@
 	/** Menu entries (ui_menu_entry_t) */
 	list_t entries;
+	/** Callbacks */
+	struct ui_menu_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** ID of device that activated entry */
+	sysarg_t idev_id;
 };
 
@@ -84,4 +89,10 @@
 extern errno_t ui_menu_paint_bg_gfx(ui_menu_t *, gfx_coord2_t *);
 extern errno_t ui_menu_paint_bg_text(ui_menu_t *, gfx_coord2_t *);
+extern void ui_menu_up(ui_menu_t *);
+extern void ui_menu_down(ui_menu_t *);
+extern void ui_menu_left(ui_menu_t *, sysarg_t);
+extern void ui_menu_right(ui_menu_t *, sysarg_t);
+extern void ui_menu_close_req(ui_menu_t *);
+extern void ui_menu_press_accel(ui_menu_t *, char32_t, sysarg_t);
 
 #endif
Index: uspace/lib/ui/private/menubar.h
===================================================================
--- uspace/lib/ui/private/menubar.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/menubar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,6 +40,8 @@
 #include <adt/list.h>
 #include <gfx/coord.h>
-#include <types/ui/menu.h>
+#include <stdbool.h>
+#include <types/common.h>
 #include <types/ui/menubar.h>
+#include <types/ui/menudd.h>
 
 /** Actual structure of menu bar.
@@ -56,11 +58,23 @@
 	/** Menu bar rectangle */
 	gfx_rect_t rect;
-	/** Selected menu or @c NULL */
-	struct ui_menu *selected;
-	/** List of menus (ui_menu_t) */
-	list_t menus;
+	/** Menu bar is active */
+	bool active;
+	/** Selected menu drop-down or @c NULL */
+	struct ui_menu_dd *selected;
+	/** List of menu drop-downs (ui_menu_dd_t) */
+	list_t menudds;
+	/** Callbacks */
+	struct ui_menu_bar_cb *cb;
+	/** Callback argument */
+	void *arg;
 };
 
-extern void ui_menu_bar_select(ui_menu_bar_t *, gfx_rect_t *, ui_menu_t *);
+extern void ui_menu_bar_select(ui_menu_bar_t *, ui_menu_dd_t *, bool, sysarg_t);
+extern void ui_menu_bar_select_sysmenu(ui_menu_bar_t *, bool, sysarg_t);
+extern void ui_menu_bar_left(ui_menu_bar_t *, sysarg_t);
+extern void ui_menu_bar_right(ui_menu_bar_t *, sysarg_t);
+extern ui_evclaim_t ui_menu_bar_key_press_unmod(ui_menu_bar_t *, kbd_event_t *);
+extern void ui_menu_bar_entry_rect(ui_menu_bar_t *, ui_menu_dd_t *,
+    gfx_rect_t *);
 
 #endif
Index: uspace/lib/ui/private/menudd.h
===================================================================
--- uspace/lib/ui/private/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/menudd.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Menu drop-down structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_MENUDD_H
+#define _UI_PRIVATE_MENUDD_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <stdbool.h>
+#include <types/ui/menudd.h>
+#include <types/ui/resource.h>
+
+/** Actual structure of menu drop-down.
+ *
+ * This is private to libui.
+ */
+struct ui_menu_dd {
+	/** Containing menu bar */
+	struct ui_menu_bar *mbar;
+	/** Link to @c bar->menudds */
+	link_t lmenudds;
+	/** Caption */
+	char *caption;
+	/** Popup window or @c NULL if drop-down is not currently open */
+	struct ui_popup *popup;
+	/** Actual menu */
+	struct ui_menu *menu;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/menuentry.h
===================================================================
--- uspace/lib/ui/private/menuentry.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/menuentry.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -53,4 +53,6 @@
 	/** Callbacks */
 	ui_menu_entry_cb_t cb;
+	/** This entry is disabled */
+	bool disabled;
 	/** This entry is a separator entry */
 	bool separator;
Index: uspace/lib/ui/private/pbutton.h
===================================================================
--- uspace/lib/ui/private/pbutton.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/pbutton.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2020 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,4 +40,5 @@
 #include <gfx/coord.h>
 #include <stdbool.h>
+#include <types/ui/pbutton.h>
 
 /** Actual structure of push button.
@@ -54,14 +55,22 @@
 	/** Callback argument */
 	void *arg;
+	/** Custom decoration ops or @c NULL */
+	struct ui_pbutton_decor_ops *decor_ops;
+	/** Decoration argument */
+	void *decor_arg;
 	/** Push button rectangle */
 	gfx_rect_t rect;
 	/** Caption */
-	const char *caption;
+	char *caption;
 	/** Button is selected as default */
 	bool isdefault;
+	/** Button light is on */
+	bool light;
 	/** Button is currently held down */
 	bool held;
 	/** Pointer is currently inside */
 	bool inside;
+	/** Push button flags */
+	ui_pbutton_flags_t flags;
 };
 
Index: uspace/lib/ui/private/popup.h
===================================================================
--- uspace/lib/ui/private/popup.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/popup.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * All rights reserved.
  *
@@ -58,4 +58,6 @@
 	/** Placement rectangle */
 	gfx_rect_t place;
+	/** ID of device that sent input event */
+	sysarg_t idev_id;
 };
 
Index: uspace/lib/ui/private/promptdialog.h
===================================================================
--- uspace/lib/ui/private/promptdialog.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/promptdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -45,5 +45,5 @@
 	/** Dialog window */
 	struct ui_window *window;
-	/** File name entry */
+	/** Text entry */
 	struct ui_entry *ename;
 	/** OK button */
Index: uspace/lib/ui/private/resource.h
===================================================================
--- uspace/lib/ui/private/resource.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/private/resource.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -66,4 +66,6 @@
 	/** Button face color */
 	gfx_color_t *btn_face_color;
+	/** Lit button face color */
+	gfx_color_t *btn_face_lit_color;
 	/** Button text color */
 	gfx_color_t *btn_text_color;
@@ -77,6 +79,12 @@
 	/** Window text color */
 	gfx_color_t *wnd_text_color;
+	/** Disabled text color */
+	gfx_color_t *wnd_dis_text_color;
+	/** Window text highlight color */
+	gfx_color_t *wnd_text_hgl_color;
 	/** Window selected text color */
 	gfx_color_t *wnd_sel_text_color;
+	/** Window selected text highlight color */
+	gfx_color_t *wnd_sel_text_hgl_color;
 	/** Window selected text background color */
 	gfx_color_t *wnd_sel_text_bg_color;
@@ -110,4 +118,9 @@
 	gfx_color_t *entry_sel_text_bg_color;
 
+	/** Scrollbar trough color */
+	gfx_color_t *sbar_trough_color;
+	/** Scrollbar active trough color */
+	gfx_color_t *sbar_act_trough_color;
+
 	/** Expose callback or @c NULL */
 	ui_expose_cb_t expose_cb;
Index: uspace/lib/ui/private/scrollbar.h
===================================================================
--- uspace/lib/ui/private/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/scrollbar.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,115 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Scrollbar structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_SCROLLBAR_H
+#define _UI_PRIVATE_SCROLLBAR_H
+
+#include <gfx/coord.h>
+#include <stdbool.h>
+#include <types/ui/scrollbar.h>
+
+/** Actual structure of scrollbar.
+ *
+ * This is private to libui.
+ */
+struct ui_scrollbar {
+	/** Base control object */
+	struct ui_control *control;
+	/** UI */
+	struct ui *ui;
+	/** UI window containing scrollbar */
+	struct ui_window *window;
+	/** Callbacks */
+	struct ui_scrollbar_cb *cb;
+	/** Callback argument */
+	void *arg;
+	/** Scrollbar rectangle */
+	gfx_rect_t rect;
+	/** Scrollbar direction */
+	ui_scrollbar_dir_t dir;
+	/** Thumb length */
+	gfx_coord_t thumb_len;
+	/** Up button */
+	struct ui_pbutton *up_btn;
+	/** Down button */
+	struct ui_pbutton *down_btn;
+	/** Thumb is currently held down */
+	bool thumb_held;
+	/** Upper trough is currently held down */
+	bool upper_trough_held;
+	/** Pointer is inside upper trough */
+	bool upper_trough_inside;
+	/** Lower trough is currently held down */
+	bool lower_trough_held;
+	/** Pointer is inside lower trough */
+	bool lower_trough_inside;
+	/** Position where thumb was pressed */
+	gfx_coord2_t press_pos;
+	/** Last thumb position */
+	gfx_coord_t last_pos;
+	/** Thumb position */
+	gfx_coord_t pos;
+	/** Last cursor position (when trough is held) */
+	gfx_coord2_t last_curs_pos;
+};
+
+/** Scrollbar geometry.
+ *
+ * Computed rectangles of scrollbar elements.
+ */
+typedef struct {
+	/** Up button rectangle */
+	gfx_rect_t up_btn_rect;
+	/** Trough rectangle */
+	gfx_rect_t trough_rect;
+	/** Upper trough rectangle */
+	gfx_rect_t upper_trough_rect;
+	/** Thumb rectangle */
+	gfx_rect_t thumb_rect;
+	/** Lower trough rectangle */
+	gfx_rect_t lower_trough_rect;
+	/** Down button rectangle */
+	gfx_rect_t down_btn_rect;
+} ui_scrollbar_geom_t;
+
+extern errno_t ui_scrollbar_paint_gfx(ui_scrollbar_t *);
+extern errno_t ui_scrollbar_paint_text(ui_scrollbar_t *);
+extern void ui_scrollbar_get_geom(ui_scrollbar_t *, ui_scrollbar_geom_t *);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/selectdialog.h
===================================================================
--- uspace/lib/ui/private/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/selectdialog.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Select dialog structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_SELECTDIALOG_H
+#define _UI_PRIVATE_SELECTDIALOG_H
+
+/** Actual structure of select dialog.
+ *
+ * This is private to libui.
+ */
+struct ui_select_dialog {
+	/** Dialog window */
+	struct ui_window *window;
+	/** List */
+	struct ui_list *list;
+	/** OK button */
+	struct ui_pbutton *bok;
+	/** Cancel button */
+	struct ui_pbutton *bcancel;
+	/** Select dialog callbacks */
+	struct ui_select_dialog_cb *cb;
+	/** Callback argument */
+	void *arg;
+};
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/ui/private/tab.h
===================================================================
--- uspace/lib/ui/private/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
+++ uspace/lib/ui/private/tab.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -0,0 +1,90 @@
+/*
+ * Copyright (c) 2023 Jiri Svoboda
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup libui
+ * @{
+ */
+/**
+ * @file Tab structure
+ *
+ */
+
+#ifndef _UI_PRIVATE_TAB_H
+#define _UI_PRIVATE_TAB_H
+
+#include <adt/list.h>
+#include <gfx/coord.h>
+#include <stdbool.h>
+#include <types/ui/tab.h>
+#include <types/ui/resource.h>
+
+/** Actual structure of tab.
+ *
+ * This is private to libui.
+ */
+struct ui_tab {
+	/** Containing tab set */
+	struct ui_tab_set *tabset;
+	/** Link to @c tabset->tabs */
+	link_t ltabs;
+	/** Caption */
+	char *caption;
+	/** X offset of the handle */
+	gfx_coord_t xoff;
+	/** Tab content */
+	struct ui_control *content;
+};
+
+/** Tab geometry.
+ *
+ * Computed rectangles of tab elements.
+ */
+typedef struct {
+	/** Tab handle */
+	gfx_rect_t handle;
+	/** Tab handle area including pull-up area */
+	gfx_rect_t handle_area;
+	/** Tab body */
+	gfx_rect_t body;
+	/** Text position */
+	gfx_coord2_t text_pos;
+} ui_tab_geom_t;
+
+extern gfx_coord_t ui_tab_handle_width(ui_tab_t *);
+extern gfx_coord_t ui_tab_handle_height(ui_tab_t *);
+extern void ui_tab_get_geom(ui_tab_t *, ui_tab_geom_t *);
+extern errno_t ui_tab_paint_handle_frame(gfx_context_t *, gfx_rect_t *,
+    gfx_coord_t, gfx_color_t *, gfx_color_t *, bool, gfx_rect_t *);
+extern errno_t ui_tab_paint_body_frame(ui_tab_t *);
+extern errno_t ui_tab_paint_frame(ui_tab_t *);
+extern ui_resource_t *ui_tab_get_res(ui_tab_t *);
+
+#endif
+
+/** @}
+ */
